# NOTE: Derived from blib/lib/Net/SOCKS.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Net::SOCKS;

#line 339 "blib/lib/Net/SOCKS.pm (autosplit into blib/lib/auto/Net/SOCKS/_request.al)"
sub _request {

  my $self    = shift;
  my $req_num = shift;
  my $rc;

  $self->_import_args(@_);
  $rc=$self->_validate();

  if ($rc != SOCKS_OKAY) { return ${*self}{status_num} = $rc }

  # connect to the SOCKS server
  $rc=$self->_connect();

  if ($rc==SOCKS_OKAY) {
    # resolve name
    unless (${*self}{peer_addr} =~ /^\d+\.\d+\.\d+\.\d+$/o) {
      #die "peer_addr not an IP adress: ${*self}{peer_addr}\n";
      #print STDERR "debug: peer_addr not an IP adress: ${*self}{peer_addr} -- resolving...\n";
      my $res = Net::DNS::Resolver->new;
      my $query = $res->search(${*self}{peer_addr});
      my $ip;
      if ($query) {
        foreach my $rr ($query->answer) {
          next unless $rr->type eq "A";
          $ip = $rr->address;
        }
      }
      $ip or die "cannot resolve name ${*self}{peer_addr}";
      ${*self}{peer_addr} = $ip;
    }

    # send the request
    print  { ${*self}{fh} } pack ('CCn', 4, $req_num, ${*self}{peer_port}) .
	inet_aton(${*self}{peer_addr}) . ${*self}{user_id} . (pack 'x');

    # get server response, returns server response code
    return $self->_get_response();
  }
  return ${*self}{status_num} = $rc;
}

# end of Net::SOCKS::_request
1;
